<template>
  <div>
    <top_nav></top_nav>
    <top_title></top_title>
    <motion_top_show v-bind:motion="motion" v-bind:approves="approves" v-if="motion"></motion_top_show>
    <items_title v-bind:title="title"></items_title>
    <motion_detail v-bind:motion="motion" v-bind:approves="approves" v-on:reload_approves='query_approvers' v-if="motion"></motion_detail>
    <br/>
    <br/>
    <br/>
    <br/>
  </div>
</template>
<script>
import { mapActions, mapState, mapMutations, mapGetters } from 'vuex';

import top_nav from '../modules/header.vue'
import top_title from '../modules/top_title.vue'
import motion_top_show from '../modules/motion_top_show.vue'
import items_title from '../modules/items_title.vue'
import motion_detail from '../modules/motion_detail.vue'

import {
  query_motions,
  query_approvers
} from '../service'

import {
  cal_day,
  mk_render_html
} from '../utils'
import { lang } from '../lang'

export default {
  data () {
    return {
      motion: null,
      title: lang.data['提案详情'],
      approves: {
        data: null,
        on_load: true
      },
      lang
    }
  },

  computed: {
    motion_id () {
      return this.$route.params.motion_id;
    },
    head_block_num () {
      return this.account_info.head_block_num;
    },
    head_block_time () {
      return this.account_info.head_block_time;
    },
    ...mapState(['account_info'])
  },

  watch: {
    motion () {
      this.query_approvers();
    }
  },

  mounted () {
    this.query_motions();
  },

  methods: {
    async query_motions () {
      let data = await query_motions(this.motion_id, 1);
      data.rows.forEach(item => {
        item.time_key = cal_day(item.approve_end_block_num, this.head_block_num);
        item.start_time = this.head_block_time.getTime() - (this.head_block_num - (item.approve_end_block_num - 14 * 24 * 1200)) * 3000;
        item.start_time = new Date(item.start_time);
        item.start_time = `${item.start_time.getFullYear()}-${ item.start_time.getMonth() + 1 }-${ item.start_time.getDate() }`
        item.content = mk_render_html(item.content);
      })
      this.motion = data.rows[0];
    },

    async query_approvers () {
      this.approves.on_load = true;
      let res = await query_approvers(this.motion.proposer, this.motion.id);
      this.approves.data = res.rows[0];
      this.approves.on_load = false;
    }

  },

  components: {
    top_nav,
    top_title,
    motion_top_show,
    items_title,
    motion_detail
  }
}
</script>